//
//  HexHelper.h
//  新宝牙刷
//
//  Created by 刘俊威 on 2017/1/13.
//  Copyright © 2017年 gizwits. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface HexHelper : NSObject

#pragma mark 十进制转十六进制
+ (NSString *)ToHex:(long long int)tmpid;

#pragma mark 求校验和
- (NSData *)getCheckSum:(NSString *)byteStr;

+ (NSData *)hexToBytes:(NSString *)str;

// 十六进制转换为普通字符串的。
+ (NSString *)stringFromHexString:(NSString *)hexString;

//普通字符串转换为十六进制。
+ (NSString *)stingToHexadecimal:(NSString *)string;

//普通字符串转换为二进制。
+ (NSString *)stingToBinary:(NSString *)string;

// 十六进制转二进制
+ (NSString *)getBinaryByhex:(NSString *)hex;

// 十六进制转换为普通字符串。
+ (NSString *)convertHexStrToString:(NSString *)hexString;

//将任意长度有符号16进制NSData类型转NSNumber（整形）
+ (NSNumber *)signedHexTurnString:(NSData *)data;

/**
 二进制代码转化成16进制字符串
 
 @param data 二进制代码
 @return 16进制字符串
 */
+ (NSString *)toString:(NSData *)data;

/**
 16进制转ASCII字符串
 
 @param str 16进制
 @return ASCII字符串
 */
+ (NSString *)toASCIIString:(NSString *)str;

// 十六进制字符串转化成有符号整型
+ (NSInteger)toHexForLong:(NSString *)str;

// 16进制转NSData
+ (NSData *)convertHexStrToData:(NSString *)str;

/**
 转换小端
 
 @param string -
 @return -
 */
+ (NSString *)transformToLittleEnd:(NSString *)string;

@end
