//
//  InternationalControl.m
//  Mayueer
//
//  Created by 金琦 on 2017/7/4.
//  Copyright © 2017年 JinQi. All rights reserved.
//    在初始化首个Controller的时候，进行应用语言的加载。首次加载因为userLanguage（应用内语言）不存在，则使用系统当前的语言，保存到userlanguage，下次直接读。读出来之后，获取到对应文件路径，得到文件的索引，储存到工具类InternationalControl的静态变量bundle中。其他地方需要用字符串时，用工具类获得bundle即可读取相应文件中的字符串。



#import "InternationalControl.h"
#import "AppDelegate.h"

NSString *const ZZAppLanguageDidChangeNotification = @"ZZAppLanguageDidChangeNotification";

//获取当前语言
#define kCURRENT_LANGUAGE ([[NSLocale preferredLanguages] objectAtIndex:0])

@implementation InternationalControl

static NSBundle *bundle = nil;

/**
 *  单例
 */
//+ (instancetype)sharedInstance {
//    static InternationalControl *sharedInstance = nil;
//
//    static dispatch_once_t onceToken;
//    dispatch_once(&onceToken, ^{
//        sharedInstance = [[self alloc] init];
//    });
//
//    return sharedInstance;
//}

+ ( NSBundle * )bundle{
    
    return bundle;
}

+ (void)initUserLanguage{
    
    NSString *string = [self userLanguage];
    
    if(!string){
        //获取系统当前语言版本(中文zh-Hans,英文en)
        NSString *current = kCURRENT_LANGUAGE;
        NSLog(@"current = %@",current);

        if ([current hasPrefix:kENGLISH]) {
            string = kENGLISH;
        }
        else if ([current hasPrefix:kTRADITIONAL]) {
            string = kTRADITIONAL;
        }
        else if ([current hasPrefix:kJAPANESE]) {
            string = kJAPANESE;;
        }
        else{
            string = kCHINESE;
        }
        [[NSUserDefaults standardUserDefaults] setValue:string forKey:kUserLanguage];
        [[NSUserDefaults standardUserDefaults] synchronize];
    }
    //获取文件路径
//    NSString *path = [[NSBundle mainBundle] pathForResource:string ofType:@"lproj"];
//    bundle = [NSBundle bundleWithPath:path];//生成bundle
}

+(NSString *)userLanguage{
    NSUserDefaults *def = [NSUserDefaults standardUserDefaults];
    NSString *language = [def valueForKey:kUserLanguage];
    return language;
}

+(void)setUserlanguage:(NSString *)language{
    
    //1.第一步改变bundle的值
//    NSString *path = [[NSBundle mainBundle] pathForResource:language ofType:@"lproj" ];
//    bundle = [NSBundle bundleWithPath:path];
    //2.持久化
    [[NSUserDefaults standardUserDefaults] setValue:language forKey:kUserLanguage];
    [[NSUserDefaults standardUserDefaults] synchronize];

//    [[NSNotificationCenter defaultCenter] postNotificationName:ZZAppLanguageDidChangeNotification object:nil];

    AppDelegate *del = (AppDelegate *)[UIApplication sharedApplication].delegate;
    [del initRootViewController];

    [[NSUserDefaults standardUserDefaults] setObject:@"1" forKey:@"NewperiPheral_Defalts"];
    [[NSUserDefaults standardUserDefaults] synchronize];

}

+(NSString *)getStringForKey:(NSString *)key {
//    return [self getStringForKey:key withTable:@"MYELocalizable"];
    return [bundle localizedStringForKey:key value:nil table:@"MYELocalizable"];
}

//+(NSString *)getStringForKey:(NSString *)key withTable:(NSString *)table{
//    if (self.bundle)
//    {
//        return NSLocalizedStringFromTableInBundle(key, table, self.bundle, @"");
//    }
//    return NSLocalizedStringFromTable(key, table, @"");
//}
//
//+ (NSString *)getString:(NSString *)string {
//    return [bundle localizedStringForKey:string value:nil table:@"myLanguage"];
//}

@end
