//
//  LeftMainView.m
//  HandheldBluetooth
//
//  Created by 伟 on 2018/10/23.
//  Copyright © 2018年 ZW. All rights reserved.
//

#import "LeftMainView.h"
#import "LeftListTableCell.h"

static NSInteger LeftMainViewWidth = 280;

@implementation LeftMainView

-(instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        [self creatUI];
    }
    return self;
}

-(void)creatUI{

    self.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.5f];

    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(-LeftMainViewWidth, 0, LeftMainViewWidth, self.frame.size.height) style:UITableViewStyleGrouped];

    if (@available(iOS 11.0, *)) {
        self.tableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;

        self.tableView.estimatedRowHeight = 0;
        self.tableView.estimatedSectionFooterHeight = 0;
        self.tableView.estimatedSectionHeaderHeight = 0;

    }

    self.tableView.backgroundColor = [UIColor blackColor];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.bounces = NO;
    self.tableView.separatorStyle = UITableViewCellAccessoryNone;
    [self addSubview:self.tableView];
    [self.tableView registerNib:[UINib nibWithNibName:@"LeftListTableCell" bundle:nil] forCellReuseIdentifier:@"LeftListTableCell"];

    self.userInteractionEnabled = YES;
    UIView *cancelView = [[UIView alloc]initWithFrame:CGRectMake(LeftMainViewWidth, 0, self.frame.size.width - LeftMainViewWidth, self.frame.size.height)];
    cancelView.backgroundColor = [UIColor clearColor];
    [self addSubview:cancelView];
    UITapGestureRecognizer *cancelTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(cancelAction)];
    [cancelView addGestureRecognizer:cancelTap];
}

-(void)cancelAction{
    [self leftTakeBack];
}

-(void)rightRemoveOut{
    [UIView animateWithDuration:0.3f animations:^{
        [self.tableView setFrame:CGRectMake(0, 0, LeftMainViewWidth, self.frame.size.height)];
    }];
}

-(void)leftTakeBack{

    __weak typeof(self) weakSelf = self;

    [UIView animateWithDuration:0.3f animations:^{

        [self.tableView setFrame:CGRectMake(-LeftMainViewWidth, 0, LeftMainViewWidth, self.frame.size.height)];

    } completion:^(BOOL finished) {

        if (weakSelf.delegate && [weakSelf.delegate respondsToSelector:@selector(animationHiddenAction)]) {
            [weakSelf.delegate animationHiddenAction];
        }

    }];

}

#pragma mark -- UITableViewDataSource
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return 5;
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    LeftListTableCell *cell = [tableView dequeueReusableCellWithIdentifier:@"LeftListTableCell" forIndexPath:indexPath];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    if (indexPath.row == self.selectNum) {
        cell.contentView.backgroundColor = JColorFromRGB(0x225569);
    }else{
        cell.contentView.backgroundColor = [UIColor blackColor];
    }
    NSArray *imgs = @[@"ic_action_bluetooth_white",@"ic_action_settings_white",@"action_search",@"ic_action_edit_white",@"ic_action_edit_white"];
    NSArray *textArr = @[@"RFID手持拍列表BT4.0",@"RFID手持拍设置",@"标签列表搜索",@"写标",@"内存访问"];
    NSArray *subTextArr = @[@"添加/移除RFID手持拍",@"RFID手持拍设置",@"标签列表搜索",@"写标",@"内存访问"];
    cell.img.image = [UIImage imageNamed:imgs[indexPath.row]];
    cell.textLb.text = Localized(textArr[indexPath.row]);
    cell.subTextLb.text = Localized(subTextArr[indexPath.row]);
    return cell;
}
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    self.selectNum = indexPath.row;
    [self.tableView reloadData];
    if (_delegate && [_delegate respondsToSelector:@selector(selectRowWithNum:)]) {
        [_delegate selectRowWithNum:indexPath.row];
    }
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 65;
}
-(CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    return 0.0000000001f;
}
-(CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    return 0.0000000001f;
    
}

@end
