//
//  MemoryAccessViewController.m
//  HandheldBluetooth
//
//  Created by 伟 on 2018/11/14.
//  Copyright © 2018年 ZW. All rights reserved.
//

#import "MemoryAccessViewController.h"
#import "SetSelectView.h"
#import "OtherModel.h"

@interface MemoryAccessViewController ()<SetSelectViewDelegate,UITextFieldDelegate,BlueToothManagerMemoryAccessDelegate>

@property (nonatomic, strong) SetSelectView *selectView;
@property (weak, nonatomic) IBOutlet UITextField *memoryTextfield;
@property (weak, nonatomic) IBOutlet UITextField *offsetTextfield;
@property (weak, nonatomic) IBOutlet UITextField *lengthTextfield;
@property (weak, nonatomic) IBOutlet UITextField *UIDTextfield;
@property (weak, nonatomic) IBOutlet UITextField *dataTextfield;
@property (weak, nonatomic) IBOutlet UITextField *resultTextfield;
@property (weak, nonatomic) IBOutlet UITextField *accessTypeTextfield;
@property (weak, nonatomic) IBOutlet UITextField *killTextfield;
@property (weak, nonatomic) IBOutlet UITextField *EPCTextfield;
@property (weak, nonatomic) IBOutlet UITextField *TIDTextfield;
@property (weak, nonatomic) IBOutlet UITextField *USERTextfield;
@property (weak, nonatomic) IBOutlet UITextField *accessTextfield;
@property (weak, nonatomic) IBOutlet UILabel *lb1;
@property (weak, nonatomic) IBOutlet UILabel *lb2;
@property (weak, nonatomic) IBOutlet UILabel *lb3;
@property (weak, nonatomic) IBOutlet UILabel *lb4;
@property (weak, nonatomic) IBOutlet UILabel *lb5;
@property (weak, nonatomic) IBOutlet UILabel *lb6;
@property (weak, nonatomic) IBOutlet UILabel *lb7;
@property (weak, nonatomic) IBOutlet UILabel *lb8;
@property (weak, nonatomic) IBOutlet UILabel *lb9;
@property (weak, nonatomic) IBOutlet UILabel *lb10;
@property (weak, nonatomic) IBOutlet UILabel *lb11;
@property (weak, nonatomic) IBOutlet UILabel *lb12;
@property (weak, nonatomic) IBOutlet UILabel *lb13;
@property (weak, nonatomic) IBOutlet UILabel *lb14;
@property (weak, nonatomic) IBOutlet UIButton *clearBtn;
@property (weak, nonatomic) IBOutlet UIButton *readBtn;
@property (weak, nonatomic) IBOutlet UIButton *writeBtn;
@property (weak, nonatomic) IBOutlet UIButton *selectBtn;
@property (weak, nonatomic) IBOutlet UIButton *lockBtn;

@property (nonatomic, assign) NSInteger selectNum;
@property (nonatomic, strong) NSArray *bankArr;
@property (nonatomic, strong) NSArray *accessArr;
@property (nonatomic, assign) NSInteger bankNum;
@property (nonatomic, strong) OtherModel *selectModel;

@end

@implementation MemoryAccessViewController

-(OtherModel *)selectModel{
    if (!_selectModel) {
        _selectModel = [OtherModel new];
    }
    return _selectModel;
}
-(NSArray *)accessArr{
    if (!_accessArr) {
        _accessArr = @[Localized(@"可访问"),Localized(@"始终可访问"),Localized(@"安全访问"),Localized(@"始终不访问"),Localized(@"无变化")];
    }
    return _accessArr;
}
-(NSArray *)bankArr{
    if (!_bankArr) {
        _bankArr = @[Localized(@"保留区"),Localized(@"EPC区"),Localized(@"TID区"),Localized(@"用户区")];
    }
    return _bankArr;
}
-(SetSelectView *)selectView{
    if (!_selectView) {
        _selectView = [[SetSelectView alloc]initWithFrame:CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight)];
        _selectView.delegate = self;
        UIWindow *keyWin = [UIApplication sharedApplication].keyWindow;
        [keyWin addSubview:_selectView];
        _selectView.hidden = YES;
    }
    return _selectView;
}
- (void)viewDidLoad {
    [super viewDidLoad];

    [self creatUI];
}

-(void)creatUI{
    self.bankNum = 1;

    self.memoryTextfield.delegate = self;
    self.accessTypeTextfield.delegate = self;
    self.killTextfield.delegate = self;
    self.EPCTextfield.delegate = self;
    self.TIDTextfield.delegate = self;
    self.USERTextfield.delegate = self;

    self.selectModel.accessNum = 4;
    self.selectModel.killNum = 4;
    self.selectModel.EPCNum = 4;
    self.selectModel.TIDNum = 4;
    self.selectModel.USERNum = 4;

    [BlueToothManager sharedManager].memoryDelegate = self;

    self.lb1.text = Localized(@"读/写/选择");
    self.lb2.text = Localized(@"内部存储");
    self.lb3.text = Localized(@"起始地址");
    self.lb4.text = Localized(@"长度");
    self.lb5.text = Localized(@"用户名");
    self.lb6.text = Localized(@"数据");
    self.lb7.text = Localized(@"状态");
    self.lb8.text = Localized(@"数据锁定");
    self.lb9.text = Localized(@"访问");
    self.lb10.text = Localized(@"销毁");
    self.lb11.text = Localized(@"EPC区");
    self.lb12.text = Localized(@"TID区");
    self.lb13.text = Localized(@"用户区");
    self.lb14.text = Localized(@"访问");
    self.memoryTextfield.text = Localized(@"EPC区");
    self.accessTypeTextfield.text = Localized(@"无变化");
    self.killTextfield.text = Localized(@"无变化");
    self.EPCTextfield.text = Localized(@"无变化");
    self.TIDTextfield.text = Localized(@"无变化");
    self.USERTextfield.text = Localized(@"无变化");
    [self.clearBtn setTitle:Localized(@"清除") forState:UIControlStateNormal];
    [self.readBtn setTitle:Localized(@"读取") forState:UIControlStateNormal];
    [self.writeBtn setTitle:Localized(@"写") forState:UIControlStateNormal];
    [self.selectBtn setTitle:Localized(@"选择") forState:UIControlStateNormal];
    [self.lockBtn setTitle:Localized(@"锁住") forState:UIControlStateNormal];
}

#pragma mark -- Event
- (IBAction)clearAction:(UIButton *)sender {
    self.UIDTextfield.text = @"";
    self.dataTextfield.text = @"";
    self.resultTextfield.text = @"";
}
- (IBAction)readAction:(UIButton *)sender {

    if (self.offsetTextfield.text.length <= 0 || self.lengthTextfield.text.length <= 0) {
        return;
    }

    NSString *hexStr = [NSString stringWithFormat:@">r %.2ld %.2ld %.2ld\r\n",self.bankNum,[self.offsetTextfield.text integerValue],[self.lengthTextfield.text integerValue]];

    [[BlueToothManager sharedManager] wirteMemoryAccessReadData:[HexHelper stingToHexadecimal:hexStr]];
}
- (IBAction)writeAction:(UIButton *)sender {

    if (self.dataTextfield.text.length <= 0 || self.offsetTextfield.text.length <= 0 || self.lengthTextfield.text.length <= 0) {
        return;
    }

    NSString *hexStr = [NSString stringWithFormat:@">w %.2ld %.2ld %.2ld %@\r\n",self.bankNum,[self.offsetTextfield.text integerValue],[self.lengthTextfield.text integerValue],self.dataTextfield.text];

    [[BlueToothManager sharedManager] wirteMemoryAccessData:[HexHelper stingToHexadecimal:hexStr]];

}
- (IBAction)selectAction:(UIButton *)sender {

    if (self.dataTextfield.text.length <= 0 || self.offsetTextfield.text.length <= 0 || self.lengthTextfield.text.length <= 0) {
        return;
    }

    NSString *hexStr = [NSString stringWithFormat:@">s %.2ld %.2ld %.2ld %@\r\n",self.bankNum,[self.offsetTextfield.text integerValue],[self.lengthTextfield.text integerValue],self.dataTextfield.text];

    [[BlueToothManager sharedManager] wirteMemoryAccessData:[HexHelper stingToHexadecimal:hexStr]];
}
- (IBAction)lockAction:(UIButton *)sender {

    if (self.accessTextfield.text.length <= 0) {
        return;
    }

    NSString *hexStr = [NSString stringWithFormat:@">l %ld %ld %ld %ld %ld %@\r\n",self.selectModel.accessNum,self.selectModel.killNum,self.selectModel.EPCNum,self.selectModel.TIDNum,self.selectModel.USERNum,self.accessTextfield.text];

    [[BlueToothManager sharedManager] wirteMemoryAccessData:[HexHelper stingToHexadecimal:hexStr]];
}

#pragma mark -- SetSelectViewDelegate
-(void)selectRowWithNum:(NSInteger)selectNum{
    if (self.selectNum == 0) {

        self.bankNum = selectNum;

        self.memoryTextfield.text = self.bankArr[selectNum];
    }else if (self.selectNum == 1){
        self.selectModel.accessNum = selectNum;

        self.accessTypeTextfield.text = self.accessArr[selectNum];
    }else if (self.selectNum == 2){
        self.selectModel.killNum = selectNum;

        self.killTextfield.text = self.accessArr[selectNum];
    }else if (self.selectNum == 3){
        self.selectModel.EPCNum = selectNum;

        self.EPCTextfield.text = self.accessArr[selectNum];
    }else if (self.selectNum == 4){
        self.selectModel.TIDNum = selectNum;

        self.TIDTextfield.text = self.accessArr[selectNum];
    }else if (self.selectNum == 5){
        self.selectModel.USERNum = selectNum;

        self.USERTextfield.text = self.accessArr[selectNum];
    }
    self.selectView.hidden = YES;
}
-(void)setViewCancelAction{
    self.selectView.hidden = YES;
}

#pragma mark -- UITextFieldDelegate
-(BOOL)textFieldShouldBeginEditing:(UITextField *)textField{
    if (textField == self.memoryTextfield) {

        [self.view endEditing:YES];
        self.selectNum = 0;
        self.selectView.dataArr = self.bankArr;
        self.selectView.hidden = NO;

        return NO;
    }else if (textField == self.accessTypeTextfield){
        [self.view endEditing:YES];
        self.selectNum = 1;
        self.selectView.dataArr = self.accessArr;
        self.selectView.hidden = NO;
        return NO;
    }else if (textField == self.killTextfield){
        [self.view endEditing:YES];
        self.selectNum = 2;
        self.selectView.dataArr = self.accessArr;
        self.selectView.hidden = NO;
        return NO;
    }else if (textField == self.EPCTextfield){
        [self.view endEditing:YES];
        self.selectNum = 3;
        self.selectView.dataArr = self.accessArr;
        self.selectView.hidden = NO;
        return NO;
    }else if (textField == self.TIDTextfield){
        [self.view endEditing:YES];
        self.selectNum = 4;
        self.selectView.dataArr = self.accessArr;
        self.selectView.hidden = NO;
        return NO;
    }else if (textField == self.USERTextfield){
        [self.view endEditing:YES];
        self.selectNum = 5;
        self.selectView.dataArr = self.accessArr;
        self.selectView.hidden = NO;
        return NO;
    }
    return YES;
}

#pragma mark -- BlueToothManagerMemoryAccessDelegate
-(void)getMemoryAccessWithReplyStr:(NSString *)replyHexStr{
    if (replyHexStr.length > 5) {
        replyHexStr = [replyHexStr substringWithRange:NSMakeRange(0, 5)];
    }
    if ([replyHexStr isEqualToString:@"00000"]) {
        self.resultTextfield.textColor = [UIColor blueColor];
        self.resultTextfield.text = @"Memory access success";
    }else{
        self.resultTextfield.textColor = [UIColor redColor];
        self.resultTextfield.text = [NSString stringWithFormat:@"Error：%@",replyHexStr];
    }
}

-(void)getMemoryReadWithReadStr:(NSString *)readHexStr{

    if (readHexStr.length > 4) {

        if (![[readHexStr substringWithRange:NSMakeRange(readHexStr.length - 4, 4)] isEqualToString:@"0D0A"]) {
            return;
        }
    }else{
        return;
    }


    if (readHexStr.length > 8) {

        NSString * hexTagListString = [readHexStr substringWithRange:NSMakeRange(0, 4)];

        if ([hexTagListString isEqualToString:@"3E52"]) {

            NSString * formalString = [readHexStr substringWithRange:NSMakeRange(4, readHexStr.length - 4 - 4)];
            NSString * ASCIIStr = [HexHelper toASCIIString:formalString];

            NSArray *dealArr = [ASCIIStr componentsSeparatedByString:@"M"];
            self.UIDTextfield.text = [dealArr firstObject];
            self.dataTextfield.text = [dealArr lastObject];
            self.resultTextfield.text = @"";
        }
    }
}

@end
